//+------------------------------------------------------------------+
//|                                       Waddah_Attar_Explosion.mq4 |
//|                              Copyright  2006, Eng. Waddah Attar |
//|                                          waddahattar@hotmail.com |
//|                                       mod. by futurespec 11.2011 |
//|                                      mod. by fxdaytrader 03.2014 |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2006, Eng. Waddah Attar (waddahattar@hotmail.com) // mod. futurespec // alerts mod. by fxdaytrader"
#property  link      "http://ForexBaron.net"
//----
#property  indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Green
#property  indicator_color2  Red
#property  indicator_color3  Sienna
#property  indicator_color4  Blue
#property  indicator_minimum 0.0

extern int  Sensetive      = 150;
extern int  DeadZonePip    = 30;
extern int  ExplosionPower = 15;
extern int  TrendPower     = 15;
extern string gahi="***** Alert settings:";
extern int  AlertCount     = 500;
extern bool AlertLong      = true;
extern bool AlertShort     = true;
extern bool AlertExitLong  = true;
extern bool AlertExitShort = true;
extern string ahi="***** Alert types:";
extern bool AlertWindow           = TRUE;
extern bool AlertEmail            = FALSE;
extern bool AlertPushNotification = FALSE;
extern bool AlertSound            = FALSE;
extern string SoundFileLong       = "alert.wav";
extern string SoundFileShort      = "alert2.wav";
extern bool   PrintToJournal      = FALSE;
bool mEmail = FALSE;
string msg;
string iName = "Waddah Attar Explosion ";
//----
double   ind_buffer1[];
double   ind_buffer2[];
double   ind_buffer3[];
double   ind_buffer4[];
//----
int LastTime1 = 1;
int LastTime2 = 1;
int LastTime3 = 1;
int LastTime4 = 1;
int Status = 0, PrevStatus = -1, mTime = 0;
double bask, bbid;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 2);
   SetIndexStyle(2, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexStyle(3, DRAW_LINE, STYLE_DOT, 1);
//----   
   SetIndexBuffer(0, ind_buffer1);
   SetIndexBuffer(1, ind_buffer2);
   SetIndexBuffer(2, ind_buffer3);
   SetIndexBuffer(3, ind_buffer4);
   
   SetIndexLabel(0, "Long");
   SetIndexLabel(1, "Short");
   SetIndexLabel(2, "Signal");
   SetIndexLabel(3, "DeadPip");
   
//----   
   IndicatorShortName("Waddah Attar Explosion: [S(" + Sensetive + 
                      ") - DZ(" + DeadZonePip + ") - EP(" + ExplosionPower + 
                      ") - TP(" + TrendPower + ")]");
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   double Trend1, Trend2, Explo1, Explo2, Dead;
   double pwrt, pwre;
   int    limit, i, handle, counted_bars = IndicatorCounted();
   string mText;
   bool mSendUpAlert, mSendDnAlert;
//----
   if(counted_bars < 0) 
       return(-1);
//----
   if(counted_bars > 0) 
       counted_bars--;
   limit = Bars - counted_bars;
//   handle=FileOpen("WAEtest.csv",FILE_CSV|FILE_WRITE|FILE_READ,','); 
     //FileWrite(1,"i","Trend1","Trend2","Explo1","Explo2","Dead","bask","bbid");  
//----
   for(i = limit - 1; i >= 0; i--)
     {
       Trend1 = (iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, i) - 
                 iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, i + 1))*Sensetive;
       Trend2 = (iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, i + 2) - 
                 iMACD(NULL, 0, 20, 40, 9, PRICE_CLOSE, MODE_MAIN, i + 3))*Sensetive;
       Explo1 = (iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, i) - 
                 iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, i));
       Explo2 = (iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_UPPER, i + 1) - 
                 iBands(NULL, 0, 20, 2, 0, PRICE_CLOSE, MODE_LOWER, i + 1));
       Dead = Point * DeadZonePip;
//       FileWrite(handle,i,Trend1,Trend2,Explo1,Explo2,Dead,bask,bbid);
       ind_buffer1[i] = 0;
       ind_buffer2[i] = 0;
       ind_buffer3[i] = 0;
       ind_buffer4[i] = 0;
       if(Trend1 >= 0)
           ind_buffer1[i] = Trend1;
       if(Trend1 < 0)
           ind_buffer2[i] = (-1*Trend1);
       ind_buffer3[i] = Explo1;
       ind_buffer4[i] = Dead;
       if(i == 0)
         {
           if(Trend1 > 0 && Trend1 > Explo1 && Trend1 > Dead && 
              Explo1 > Dead && Explo1 > Explo2 && Trend1 > Trend2 && 
              LastTime1 < AlertCount && AlertLong == true && Ask != bask)
             {
               pwrt = 100*(Trend1 - Trend2) / Trend1;
               pwre = 100*(Explo1 - Explo2) / Explo1;
               bask = Ask;
               if(pwre >= ExplosionPower && pwrt >= TrendPower)
                 {
                   msg = LastTime1+ " - BUY "+ " (at "+ 
                             DoubleToStr(bask, Digits) + ") Trend PWR " + 
                             DoubleToStr(pwrt,0)+ " - Exp PWR "+ DoubleToStr(pwre, 0);
                   doAlerts(msg,SoundFileLong);
                   LastTime1++;
                 }
               Status = 1;
             }
           if(Trend1 < 0 && MathAbs(Trend1) > Explo1 && MathAbs(Trend1) > Dead && 
              Explo1 > Dead && Explo1 > Explo2 && MathAbs(Trend1) > MathAbs(Trend2) && 
              LastTime2 < AlertCount && AlertShort == true && Bid != bbid)
             {
               pwrt = 100*(MathAbs(Trend1) - MathAbs(Trend2)) / MathAbs(Trend1);
               pwre = 100*(Explo1 - Explo2) / Explo1;
               bbid = Bid;
               if(pwre >= ExplosionPower && pwrt >= TrendPower)
                 {
                   msg = LastTime2+ " - SELL "+ " (at "+ 
                             DoubleToStr(bbid, Digits)+ ") Trend PWR "+ 
                             DoubleToStr(pwrt,0)+ " - Exp PWR "+ DoubleToStr(pwre, 0);
                   doAlerts(msg,SoundFileShort);
                   LastTime2++;
                 }
               Status = 2;
             }
           if(Trend1 > 0 && Trend1 < Explo1 && Trend1 < Trend2 && Trend2 > Explo2 && 
              Trend1 > Dead && Explo1 > Dead && LastTime3 <= AlertCount && 
              AlertExitLong == true && Bid != bbid)
             {
               bbid = Bid;

                   msg = LastTime3+ " - Exit BUY "+ "at "+
                         DoubleToStr(bbid, Digits);
               doAlerts(msg,SoundFileShort);
               Status = 3;
               LastTime3++;
             }
           if(Trend1 < 0 && MathAbs(Trend1) < Explo1 && 
              MathAbs(Trend1) < MathAbs(Trend2) && MathAbs(Trend2) > Explo2 && 
              Trend1 > Dead && Explo1 > Dead && LastTime4 <= AlertCount && 
              AlertExitShort == true && Ask != bask)
             {
               bask = Ask;
                   msg = LastTime4+ " - Exit SELL "+ "at "+ 
                         DoubleToStr(bask, Digits);
               doAlerts(msg,SoundFileLong);
               Status = 4;
               LastTime4++;
             }
           PrevStatus = Status;
         }
       if(Status != PrevStatus)
         {
           LastTime1 = 1;
           LastTime2 = 1;
           LastTime3 = 1;
           LastTime4 = 1;
         }
         
       if(mSendUpAlert && Time[0] > mTime && i == 0 && ind_buffer1[1] > ind_buffer3[1] && ind_buffer1[1] > 
           ind_buffer4[1] && ind_buffer1[2] < ind_buffer3[2])
         {
          mText = Hour() + ":" + Minute() + " \n" + Symbol() + " Attar Indicator Alert UP \n\n" + 
                  DoubleToStr(Close[0], Digits);
          if(mEmail)
            SendMail("Attar ALERT", mText);
          mSendUpAlert = false;
          mSendDnAlert = true;
          mTime = Time[0];
         }
       else
        {
         if(mSendDnAlert && Time[0] > mTime && i == 0 && ind_buffer2[1] > ind_buffer3[1] && ind_buffer2[1] > 
                  ind_buffer4[1] && ind_buffer2[2] < ind_buffer3[2])
           {
            mText = Hour() + ":" + Minute() + " \n" + Symbol() + " Attar Indicator Alert DOWN \n\n" + 
                    DoubleToStr(Close[0], Digits);
           if(mEmail)
            SendMail("Attar ALERT", mText);
            mSendDnAlert = false;
            mSendUpAlert = true;
            mTime = Time[0];
           }
        }  
     }
   return(0);
  }
//+------------------------------------------------------------------+

void doAlerts(string msg,string SoundFileName) {
        msg=iName+", Alert on "+Symbol()+", period "+TFtoStr(Period())+": "+msg;
 string emailsubject="MT4 alert on acc. "+AccountNumber()+", "+WindowExpertName()+" - Alert on "+Symbol()+", period "+TFtoStr(Period());
  if (AlertWindow) Alert(msg);
  if (AlertEmail) SendMail(emailsubject,msg);
  if (AlertPushNotification) SendNotification(msg);
  if (AlertSound) PlaySound(SoundFileName);
  if (PrintToJournal) Print(msg);
}//void doAlerts(string msg,string SoundFile) {

string TFtoStr(int period) {
 if (period==0) period=Period();
 switch(period) {
  case 1     : return("M1");  break;
  case 5     : return("M5");  break;
  case 15    : return("M15"); break;
  case 30    : return("M30"); break;
  case 60    : return("H1");  break;
  case 240   : return("H4");  break;
  case 1440  : return("D1");  break;
  case 10080 : return("W1");  break;
  case 43200 : return("MN1"); break;
  default    : return(DoubleToStr(period,0));
 }
 return("UNKNOWN");
}//string TFtoStr(int period) {